from functools import partial
from os import getpid

from werkzeug.local import LocalProxy
from .local import LocalGlobalStack
from .exceptions import WorkingOutsideOfContext

def _swarm():
    bottom = _swarm_ctx_stack.bottom
    if bottom is None:
        raise WorkingOutsideOfContext('swarm')
    return bottom

# def _process():
#     bottom = _process_ctx_stack.bottom
#     if bottom is None:
#         raise WorkingOutsideOfContext('process')
#     return bottom


def _transport():
    bottom = _transport_ctx_stack.bottom
    if bottom is None:
        raise WorkingOutsideOfContext('transport')
    return bottom


_swarm_ctx_stack = LocalGlobalStack()
# _process_ctx_stack = LocalGlobalStack()
_transport_ctx_stack = LocalGlobalStack()



def get_stacks():
    return {
    'swarm':LocalProxy(_swarm),
    'transport':LocalProxy(_transport),
    }
locals().update(get_stacks())