from swarm import HttpSwarm as Swarm, retrieve, spider, swarm, response
from swarm import define_swarm
from swarm.helpers import parser


google = Swarm(__name__)

#Example task
#Search google by given keyword and return 
#[[item url, all urls from items page that contains searched keyword], ...]

@parser
def pagination_links(html):
    return html.xpath('//a[@class="pagination"]/@href')

@parser
def hrefs(html):
    return html.xpath('//a/@href')

@parser
def items(html):
    return html.xpath('//a[@class="search-item"]/@href')

@define_swarm.start()

@google.spider('/links/<path:url>')
def links(url):
    with retrieve(url) << _:
        for item in hrefs():
            yield item

@google.spider('/search/<keyword>')
def search(keyword):
    mentioning_urls = lambda item:[url for url in google('/links/%s'%item) if keyword in url]
    with swarm('http://google.com.ua?query=%s'%keyword) << _:
        with swarm(*pagination_links()) << _:
            for item in items():
                yield item, mentioning_urls(item)

        for item in items():
            yield item, mentioning_urls(item)

@define_swarm.finish()

if name == '__main__':
    print list(google('younews')):
        