import unittest
from swarm import BaseSwarm as Swarm

from swarm import define_swarm, swarm
from os import path
from multiprocessing import current_process, log_to_stderr, active_children


import logging
from logging import *
# log_to_stderr(logging.DEBUG)
from threading import current_thread, enumerate
from pprint import pprint
import time



def mklogger():
    log_to_stderr(logging.DEBUG)
# mklogger()


def ident():
    return  (current_process().pid, id(current_thread()))

from pprint import pprint
from traceback import print_exc
import time

define_swarm.start()
test = Swarm(__name__)

class TestConfig(object):
    LOG_DATE_FORMAT = "%H:%M:%S"
    DEBUG = True



test.config.from_object(TestConfig)


@test.url('/subcontext0')
def test_subcontext0():
    v = 'abc'
    yield 'PASSING GATES'
    z = 'CALLED'
    def ttt():
        return z

    def zzz(z):
        return z

    with swarm(1) << 'zzz, ttt, v, z, k=2':
        yield 'FROM ABOVE THE FRINGE'
        v = 'def'
        z = 'SUBCALLED'
        with swarm(2) << _:
            yield z
            with swarm(4, 5) << _:
                with swarm(44, 55) << 'v':
                    yield v
                    with swarm(77, 88) << _:
                        yield 1


@test.url('/subcontext1')
def test_subcontext1():
    yield 'PASSING GATES'    
    z = 'SUBCALLED'
    for i in range(20):
        with swarm(2, 3, 4, 5, 6) << 'z':
            yield z
            with swarm(4, 5) << 'z':
                yield z
            with swarm(5, 6) << 'z':
                yield z


@test.url('/superswarm0')
def test_super():
    yield list(test('/subswarm0'))
    yield list(test('/subswarm1'))

@test.url('/subswarm0')
def test_subswarm0():
    yield 1

@test.url('/subswarm1')
def test_subswarm1():
    yield 2

@test.url('/superswarm1')
def test_subcontext_subswarm1():
    with swarm(*range(8)) << _:
        yield list(test('/subswarm0'))
        yield list(test('/subswarm1'))

@test.url('/superswarm2')
def test_subcontext_subswarm2():
    with swarm(1) << _:
        # yield list(test('/subswarm0'))
        yield list(test('/subswarm1'))


@test.url('/subcontext_subswarm')
def test_subcontext_subswarm():
    v = 'abc'
    yield 'PASSING GATES'
    z = 'CALLED'
    def ttt():
        return z

    def zzz(z):
        return z

    with swarm(1) << 'zzz, ttt, v, z, k=2':
        yield 'FROM ABOVE THE FRINGE'
        v = 'def'
        z = 'SUBCALLED'
        yield ttt()
        with swarm(2) << _:
            yield z
            with swarm(4, 5) << _:
                with swarm(44, 55) << 'v':
                    yield v
                    with swarm(77, 88) << _:
                        yield list(test('/superswarm2'))
define_swarm.finish()

for COMPETITORS in (
                    1,
                    2,
                    5,
                    50,
                    ):
    for RESOLUTION in (
                       1,
                       0.1,
                       0.01,
                       # 0.001,
                       ):

        class TestConcept(unittest.TestCase):
            competitors = COMPETITORS
            resolution = RESOLUTION
            def setUp(self):
                test.config['COMPETITORS'] = self.competitors
                test.config['RESOLUTION'] = self.resolution
                print
                print 'Competitors:', test.competitors
                print 'Resolution:', test.resolution
                self.start = time.time()
            def tearDown(self):
                self.assertTrue(not active_children())
                print '--- took :%s' % (time.time() - self.start)

            def test_deep_subcontext(self):
                l = list(test('/subcontext0'))
                self.assertTrue ( l == ['PASSING GATES',
                                                      'FROM ABOVE THE FRINGE',
                                                      'SUBCALLED',
                                                      'def',
                                                      'def',
                                                      'def',
                                                      'def',
                                                      1,
                                                      1,
                                                      1,
                                                      1,
                                                      1,
                                                      1,
                                                      1,
                                                      1])


            def test_wide_subcontext(self):
                self.assertTrue( len(list(test('/subcontext1'))) == 501)

            def test_subswarm(self):
                self.assertTrue(list(test('/superswarm0')) == [[1], [2]])

            def test_subcontext_subswarm(self):
                # print
                l = list(test('/superswarm1'))
                print l
                self.assertTrue(len(l) == 16)

            def test_deep_subcontext_subswarm(self):
                self.assertTrue (list(test('/subcontext_subswarm')) == ['PASSING GATES',
                                                                        'FROM ABOVE THE FRINGE',
                                                                        'CALLED',
                                                                        'SUBCALLED',
                                                                        'def',
                                                                        'def',
                                                                        'def',
                                                                        'def',
                                                                        [[2]],
                                                                        [[2]],
                                                                        [[2]],
                                                                        [[2]],
                                                                        [[2]],
                                                                        [[2]],
                                                                        [[2]],
                                                                        [[2]]])

        locals()['TestConcept_%s_%s'%(COMPETITORS, RESOLUTION)] = TestConcept
        locals()['TestConcept_%s_%s'%(COMPETITORS, RESOLUTION)].__name__ = 'TestConcept_%s_%s'%(COMPETITORS, RESOLUTION)
        del TestConcept

if __name__ == '__main__':
    unittest.main()