import unittest
from swarm import BaseSwarm as Swarm
from swarm.signals import *

from swarm import define_swarm, swarm
from os import path
from multiprocessing import current_process, log_to_stderr, active_children



import logging
from threading import current_thread
from pprint import pprint
import time



def mklogger():
    log_to_stderr(logging.DEBUG)
# mklogger()


def ident():
    return  (current_process().pid, id(current_thread()))

from pprint import pprint
from traceback import print_exc
import time

define_swarm.start()

test = Swarm(__name__)
subtest = Swarm('sub_%s'%__name__)
test_prepare = Swarm('prepare_%s'%__name__)
test_cancel = Swarm('cancel_%s'%__name__)
test_multiple = Swarm('multiple_%s'%__name__)

class Config(object):
    DEBUG = True

class TopswarmTestConfig(Config):
    pass

class SubswarmTestConfig(Config):
    RELOADED_MODULE = 'test.signals.sig0'

class TestPrepareConfig(Config):
    RELOADED_MODULE = 'test.signals.sig1'

class TestCancelConfig(Config):
    RELOADED_MODULE = 'test.signals.sig2'

class TestMultpleSignalModulesConfig(Config):
    RELOADED_MODULE = ('test.signals.sig4', 'test.signals.sig3')

test.config.from_object(TopswarmTestConfig)
subtest.config.from_object(SubswarmTestConfig)
test_prepare.config.from_object(TestPrepareConfig)
test_cancel.config.from_object(TestCancelConfig)
test_multiple.config.from_object(TestMultpleSignalModulesConfig)

@subtest.url('/emit_signal')
def test_emit_signal():
    pass

@test.url('/simultaneous_signals')
def test_simultaneous_signals():
    with swarm(1, 2, 3, 4, 5) << _:
        list(subtest('/emit_signal'))


@test_prepare.url('/prepare_swarm')
def test_prepare_signal():
    with swarm(1, 2, 3, 4, 5) << _:
        swarm.test_dict[transport.args[0]] = 'Done'
        yield swarm.test_dict.keys()

@test_cancel.url('/test')
def cancel_apply():
    with swarm(1) << _:
        yield 1


@test_multiple.url('/test')
def multiple_signal():
    with swarm(1) << _:
        yield 1


define_swarm.finish()



for COMPETITORS in (
                    1,
                    2,
                    5,
                    50,
                    ):
    for RESOLUTION in (
                       1,
                       0.1,
                       0.01,
                       # 0.001,
                       ):

        class TestConcept(unittest.TestCase):
            competitors = COMPETITORS
            resolution = RESOLUTION
            def setUp(self):
                test.config['COMPETITORS'] = self.competitors
                test.config['RESOLUTION'] = self.resolution
                test_prepare.config['COMPETITORS'] = self.competitors
                test_prepare.config['RESOLUTION'] = self.resolution

                print
                print 'Competitors:', test.competitors
                print 'Resolution:', test.resolution
                self.start = time.time()
            def tearDown(self):
                self.assertTrue(not active_children())
                print '--- took :%s' % (time.time() - self.start)

            def test_signal_locking(self):
                start = time.time()
                list(test('/simultaneous_signals'))
                self.assertTrue((time.time() - start) > 5)

            def test_prepare_swarm(self):
                self.assertTrue([1, 2, 3, 4, 5] in list(test_prepare('/prepare_swarm')))

            def test_logged_cancel(self):
                self.assertFalse(bool(list(test_cancel('/test'))))

            def test_multiple_signal_modules(self):
                print list(test_multiple('/test'))



        locals()['TestConcept_%s_%s'%(COMPETITORS, RESOLUTION)] = TestConcept
        locals()['TestConcept_%s_%s'%(COMPETITORS, RESOLUTION)].__name__ = 'TestConcept_%s_%s'%(COMPETITORS, RESOLUTION)
        del TestConcept
